type token =
  | Lint of (Io_types.pos * int)
  | Lstring of (Io_types.pos * string)
  | Lident of (Io_types.pos * string)
  | Llpar
  | Lrpar
  | Lsemi
  | Lcolon
  | Lperiod
  | Llambda of (Io_types.pos)
  | Lputvar of (Io_types.pos)
  | Lgetvar of (Io_types.pos)
  | Lend
  | Ldeclare of (Io_types.pos)
  | Lprimitive of (Io_types.pos)
  | Lvariable of (Io_types.pos)
  | Lexport of (Io_types.pos)
  | Limport of (Io_types.pos)

val parse_io_module :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Io_types.io_ast
