#  Order module (order.io)
#  Amalthea standard Io library
#  (c)2002 Martin Sandin (msandin@hotmail.com)
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

import prelude.
export
  Order
  order_before
  order_same
  order_after
  .
  
declare Order: -> lt eq return;
  Tuple lt eq -> order;
  return order.

declare order_before: -> order a b true false;
  order -> lt _;
  lt a b true false.

declare order_same: -> order a b true false;
  order -> _ eq;
  eq a b true false.

declare order_after: -> order a b true false;
  order -> lt eq;
  lt a b false;
  eq a b false;
  true.

# Demo
print_string "Amalthea standard Io library: Order module";

terminate