declare invalidTree: ->;
    print_string "Bad Tree";
    terminate.


declare writeTree: -> ATree Continuation;
    ATree invalidTree -> First LeftTree RightTree;
    = First 1073741823 (Continuation);
    writeTree LeftTree;
    print_int First;
    writeTree RightTree;
    Continuation.

declare newWriteTree: -> ATree Spaces Continuation;
    ATree invalidTree -> First LeftTree RightTree;
    = First 1073741823 (Continuation);
    ^ "   " Spaces -> NewSpaces;
    newWriteTree LeftTree NewSpaces;
    print_string_ Spaces;
    print_int First;
    newWriteTree RightTree NewSpaces;
    Continuation.

declare printTree: -> ATree Continuation;
    newWriteTree ATree "";
    Continuation.

declare createTree: -> Number NClient;
    ConsTree 1073741823 EmptyTree EmptyTree -> LeftTree;
    ConsTree 1073741823 EmptyTree EmptyTree -> RightTree;
    ConsTree Number LeftTree RightTree -> NewTree;
    NClient NewTree.

declare insertTree: -> Number ATree TClient;
    ATree invalidTree -> First LeftTree RightTree;
    = First 1073741823 (createTree Number -> NewTree; TClient NewTree);
    > Number First (insertTree Number RightTree -> RightTree; ConsTree First LeftTree RightTree -> NewTree; TClient NewTree);
    insertTree Number LeftTree -> LeftTree;
    ConsTree First LeftTree RightTree -> NewTree;
    TClient NewTree.

declare depth: -> ATree NClient;
    ATree invalidTree -> First LeftTree RightTree;
    = First 1073741823 (NClient 0);
    depth LeftTree -> Leftdepth;
    depth RightTree -> Rightdepth;
    > Leftdepth Rightdepth(+ Leftdepth 1 -> Newdepth; NClient Newdepth);
    + Rightdepth 1 -> Newdepth;
    NClient Newdepth.

declare countTree: -> ATree NClient;
    ATree invalidTree -> First LeftTree RightTree;
    = First 1073741823 (NClient 0);
    countTree LeftTree -> LeftCount;
    countTree RightTree -> RightCount;
    + LeftCount RightCount -> NewCount;
    + NewCount 1 -> NewCount;
    NClient NewCount.

declare ConsTree: -> Number LeftTree RightTree TClient;
    TClient -> Null NotNull;
    NotNull Number LeftTree RightTree.

declare EmptyTree: -> Null NotNull;
    Null.

declare compareTreeStrictRecursive: -> Tree1 Tree2 NClient;
    Tree1 invalidTree -> First1 LeftTree1 RightTree1;
    Tree2 invalidTree -> First2 LeftTree2 RightTree2;
    = First1 First2 (= First1 1073741823 (NClient 0); compareTreeStrictRecursive LeftTree1 LeftTree2 -> Num1; compareTreeStrictRecursive RightTree1 RightTree2 -> Num2; + Num1 Num2 -> Result; > Result 0 (NClient 1); NClient 0);
    NClient 1.

declare equalTree: -> Continuation;
    print_string "Trees Equal";
    Continuation.

declare notEqualTree: -> Continuation;
    print_string "Trees inequal";
    Continuation.

declare compareTreeStrict: -> Tree1 Tree2 pathy pathn Continuation;
    compareTreeStrictRecursive Tree1 Tree2 -> Result;
    = Result 0 (pathy Continuation);
    pathn Continuation.

declare addTen: -> Num NClient;
    + Num 10 -> Result;
    NClient Result.

declare mapCarTree: -> ATree AnAction TClient;
    ATree invalidTree -> First LeftTree RightTree;
    = First 1073741823 (TClient ATree);
    AnAction First -> Result;
    mapCarTree LeftTree AnAction -> NewLeftTree;
    mapCarTree RightTree AnAction -> NewRightTree;
    ConsTree Result NewLeftTree NewRightTree -> EndTree;
    TClient EndTree.

declare makeTree1: -> TClient;
    createTree 20 -> Tree1;
    insertTree 10 Tree1 -> Tree2;
    insertTree 30 Tree2 -> Tree3;
    insertTree 5 Tree3 -> Tree4;
    insertTree 7 Tree4 -> Tree5;
    insertTree 15 Tree5 -> Tree6;
    insertTree 4 Tree6 -> Tree7;
    insertTree 3 Tree7 -> Tree8;
    insertTree 2 Tree8 -> Tree9;
    insertTree 1 Tree9 -> Tree10;
    insertTree 11 Tree10 -> Tree11;
    insertTree 35 Tree11 -> Tree12;
    TClient Tree12.

declare makeTree2: -> TClient;
    createTree 20 -> Tree1;
    insertTree 10 Tree1 -> Tree2;
    insertTree 30 Tree2 -> Tree3;
    insertTree 4 Tree3 -> Tree4;
    insertTree 5 Tree4 -> Tree5;
    insertTree 7 Tree5 -> Tree6;
    insertTree 15 Tree6 -> Tree7;
    insertTree 3 Tree7 -> Tree8;
    insertTree 2 Tree8 -> Tree9;
    insertTree 1 Tree9 -> Tree10;
    insertTree 11 Tree10 -> Tree11;
    insertTree 35 Tree11 -> Tree12;
    TClient Tree12.

makeTree1 -> Tree1;
print_string "Tree1";
printTree Tree1;
print_string "Tree2";
makeTree2 -> Tree2;
printTree Tree2;
print_string "Attempt at Comparison";
compareTreeStrict Tree1 Tree2 equalTree notEqualTree;
print_string "mapCar: Tree1 + 10";
mapCarTree Tree1 addTen -> NewTree;
printTree NewTree;
terminate
