declare invalidTree: Tree ->;
    print_string "Bad Tree";
    terminate.

declare doubleInvalidTree:->;
    invalidTree invalidTree.


declare WriteTree: -> Tree Continuation;
    Tree doubleInvalidTree -> First LeftTree RightTree;
    = First 1073741823 (Continuation);
    WriteTree LeftTree;
    print_int First;
    WriteTree RightTree;
    Continuation.

declare newWriteTree: -> Tree Spaces Continuation;
    Tree doubleInvalidTree -> First LeftTree RightTree;
    = First 1073741823 (Continuation);
    ^ "   " Spaces -> NewSpaces;
    newWriteTree LeftTree NewSpaces;
    print_string_ Spaces;
    print_int First;
    newWriteTree RightTree NewSpaces;
    Continuation.

declare PrintTree: -> Tree Continuation;
    newWriteTree Tree "";
    Continuation.

declare CreateTree: -> Number NContinuation;
    ConsTree 1073741823 EmptyTree EmptyTree -> LeftTree;
    ConsTree 1073741823 EmptyTree EmptyTree -> RightTree;
    ConsTree Number LeftTree RightTree -> NewTree;
    NContinuation NewTree.

declare InsertTree: -> Number Tree TContinuation;
    Tree doubleInvalidTree -> First LeftTree RightTree;
    = First 1073741823 (CreateTree Number -> NewTree; TContinuation NewTree);
    > Number First (InsertTree Number RightTree -> RightTree; ConsTree First LeftTree RightTree -> NewTree; TContinuation NewTree);
    InsertTree Number LeftTree -> LeftTree;
    ConsTree First LeftTree RightTree -> NewTree;
    TContinuation NewTree.

declare Depth: -> Tree NContinuation;
    Tree doubleInvalidTree -> First LeftTree RightTree;
    = First 1073741823 (NContinuation 0);
    Depth LeftTree -> LeftDepth;
    Depth RightTree -> RightDepth;
    > LeftDepth RightDepth(+ LeftDepth 1 -> NewDepth; NContinuation NewDepth);
    + RightDepth 1 -> NewDepth;
    NContinuation NewDepth.

declare MyCountTree: -> Tree NContinuation;
    Tree doubleInvalidTree -> First LeftTree RightTree;
    = First 1073741823 (NContinuation 0);
    MyCountTree LeftTree -> LeftCount;
    MyCountTree RightTree -> RightCount;
    + LeftCount RightCount -> NewCount;
    + NewCount 1 -> NewCount;
    NContinuation NewCount.

declare ConsTree: -> Number LeftTree RightTree TContinuation;
    TContinuation -> Null Null NotNull;
    NotNull Number LeftTree RightTree.

declare EmptyTree: -> Null Null NotNull;
    Null.

declare CompareTreeStrictRecursive: -> Tree1 Tree2 NContinuation;
    Tree1 invalidTree invalidTree -> First1 LeftTree1 RightTree1;
    Tree2 invalidTree invalidTree -> First2 LeftTree2 RightTree2;
    = First1 First2 (= First1 1073741823 (NContinuation 0); CompareTreeStrictRecursive LeftTree1 LeftTree2 -> Num1; CompareTreeStrictRecursive RightTree1 RightTree2 -> Num2; + Num1 Num2 -> result; > result 0 (NContinuation 1); NContinuation 0);
    NContinuation 1.

declare EqualTree: -> Continuation;
    print_string "Trees Equal";
    Continuation.

declare NotEqualTree: -> Continuation;
    print_string "Trees inequal";
    Continuation.

declare CompareTreeStrict: -> Tree1 Tree2 pathy pathn Continuation;
    CompareTreeStrictRecursive Tree1 Tree2 -> result;
    = result 0 (pathy Continuation);
    pathn Continuation.

declare addTen: -> num NContinuation;
    + num 10 -> result;
    NContinuation result.

declare FunctionTree: -> Tree Function TContinuation;
    Tree invalidTree invalidTree -> First LeftTree RightTree;
    = First 1073741823 (TContinuation Tree);
    Function First -> result;
    FunctionTree LeftTree Function -> newLeftTree;
    FunctionTree RightTree Function -> newRightTree;
    ConsTree result newLeftTree newRightTree -> endTree;
    TContinuation endTree.

declare MakeTree1: -> TContinuation;
    CreateTree 20 -> Tree;
    InsertTree 10 Tree -> Tree;
    InsertTree 30 Tree -> Tree;
    InsertTree 5 Tree -> Tree;
    InsertTree 7 Tree -> Tree;
    InsertTree 15 Tree -> Tree;
    InsertTree 4 Tree -> Tree;
    InsertTree 3 Tree -> Tree;
    InsertTree 2 Tree -> Tree;
    InsertTree 1 Tree -> Tree;
    InsertTree 11 Tree -> Tree;
    InsertTree 35 Tree -> Tree;
    TContinuation Tree.

declare MakeTree2: -> TContinuation;
    CreateTree 20 -> Tree;
    InsertTree 10 Tree -> Tree;
    InsertTree 30 Tree -> Tree;
    InsertTree 4 Tree -> Tree;
    InsertTree 5 Tree -> Tree;
    InsertTree 7 Tree -> Tree;
    InsertTree 15 Tree -> Tree;
    InsertTree 3 Tree -> Tree;
    InsertTree 2 Tree -> Tree;
    InsertTree 1 Tree -> Tree;
    InsertTree 11 Tree -> Tree;
    InsertTree 35 Tree -> Tree;
    TContinuation Tree.

MakeTree1 -> Tree1;
MakeTree2 -> Tree2;
Depth Tree1 -> TreeDepth;
print_int TreeDepth;
MyCountTree Tree1 -> TreeCount;
print_int TreeCount;
PrintTree Tree1;
print_string "Attempt at Comparison";
CompareTreeStrict Tree1 Tree2 EqualTree NotEqualTree;
PrintTree Tree1;
FunctionTree Tree1 addTen -> newTree;
PrintTree newTree;
terminate
