declare invalidList: ->;
	print_string "bad list";
	terminate.

declare emptyList: -> Null NotNull;
	Null.

declare cons: -> Number AList LClient;
	LClient -> Null NotNull;
	NotNull Number AList.

declare insert: -> Number AList LClient;
	AList (invalidList) -> First Rest;
	= First 1073741823 (cons Number AList -> List4; LClient List4);
	< Number First (cons Number AList -> List5; LClient List5);
	insert Number Rest -> List2;
	cons First List2 -> List3;
	LClient List3.

declare listCount: -> AList NClient;
	AList (invalidList) -> First Rest;
	= First 1073741823 (NClient 0);
	listCount Rest -> Result;
	+ 1 Result -> NewResult;
	NClient NewResult.

declare Delete: -> Number AList LClient;
	AList (invalidList) -> First Rest;
	= First 1073741823 (LClient AList);
	= First Number (LClient Rest);
	> First Number (LClient AList);
	Delete Number Rest -> List1;
	cons First List1 -> List2;
	LClient List2.

declare initializeList: -> LClient;
	cons 1073741823 emptyList -> AList;
	LClient AList.

declare printList: -> AList Continuation;
	AList (invalidList) -> First Rest;
	= First 1073741823 (Continuation);
	print_int First;
	printList Rest;
	Continuation.

declare print1: -> Continuation;
    print_string "First is Larger";
    Continuation.

declare print2: -> Continuation;
    print_string "Second is Larger";
    Continuation.

declare print3: -> Continuation;
    print_string "Lists are Equal!";
    Continuation.

declare compareList: -> List1 List2 Path1 Path2 Path3 Continuation;
    List1 (invalidList) -> First1 Rest1;
    List2 (invalidList) -> First2 Rest2;
    = First1 First2 (= First1 1073741823 (Path3 Continuation); compareList Rest1 Rest2 Path1 Path2 Path3 Continuation);
    = First2 1073741823 (Path1 Continuation);
    = First1 1073741823 (Path2 Continuation);
    > First1 First2 (Path1 Continuation);
    Path2 Continuation.

declare addTen: -> Num NClient;
    + Num 10 -> Result;
    NClient Result.

declare mapCar: -> List AnAction LClient;
    List (invalidList) -> First Rest;
    = First 1073741823 (LClient List);
    AnAction First -> Result;
    mapCar Rest AnAction -> NewRest;
    cons Result NewRest -> NewList;
    LClient NewList.

declare map2Car: -> List1 List2 AnAction LClient;
    List1 invalidList -> First1 Rest1;
    List2 invalidList -> First2 Rest2;
    = First1 1073741823 (= First1 First2 (initializeList -> List3; LClient List3); print_string "WARNING: Lists of unequal Length"; initializeList -> List4; LClient List4);
    = First2 1073741823 (print_string "WARNING: Lists of unequal Length"; initializeList -> List4; LClient List4);
    AnAction First1 First2 -> result;
    map2Car Rest1 Rest2 AnAction -> newList;
    cons result newList -> returnList;
    LClient returnList.

declare addAction: -> Num1 Num2 NClient;
    + Num1 Num2 -> Num3;
    + Num3 100 -> Num4;
    NClient Num4.

declare makeList1: -> LClient;
    initializeList -> List1;
    insert 4 List1 -> List2;
    insert 2 List2 -> List3;
    insert 5 List3 -> List4;
    insert 10 List4 -> List5;
    insert 20 List5 -> List6;
    insert 7 List6 -> List7;
    insert 40 List7 -> List8;
    LClient List8.

declare makeList2: -> LClient;
    initializeList -> List1;
    insert 4 List1 -> List2;
    insert 2 List2 -> List3;
    insert 5 List3 -> List4;
    insert 10 List4 -> List5;
    insert 20 List5 -> List6;
    insert 7 List6 -> List7;
    insert 30 List7 -> List8;
    LClient List8.

makeList1 -> List1;
print_string "Original list";
printList List1;
makeList2 -> List2;
print_string "Second list";
printList List2;
print_string "Compare lists";
compareList List1 List2 (print1) (print2) (print3);
print_string "mapCar: List1 + 10";
mapCar List1 addTen -> NewList;
printList NewList;
print_string "map2Car: List1 + List2 + 100";
map2Car List1 List2 addAction -> ListFinal;
printList ListFinal;
terminate
